"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var Memos = new WeakMap();
var initMemo = function initMemo(method) {
    if (!Memos.has(method)) {
        Memos.set(method, new Map());
    }
    return Memos.get(method);
};

var refresh = function refresh(method) {
    var map = initMemo(method);
    return function () {
        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        var _ret = method.apply(undefined, _toConsumableArray(args));
        var _args = JSON.stringify(args);
        map.set(_args, _ret);
        return _ret;
    };
};

var memoize = function memoize(method) {
    var map = initMemo(method);
    var ret = function ret() {
        for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
            args[_key2] = arguments[_key2];
        }

        var _ret = null;
        var _args = JSON.stringify(args);

        if (!map.has(_args)) {
            _ret = method.apply(undefined, _toConsumableArray(args));
            map.set(_args, _ret);
        } else {
            _ret = map.get(_args);
        }

        return _ret;
    };
    ret.refresh = refresh(method);
    return ret;
};

memoize.refresh = refresh;
exports.default = memoize;
module.exports = exports["default"];